package com.xhly.manageapp.viewmodel

import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import com.xhly.corelib.base.viewmodel.CommonBaseViewModel
import com.xhly.corelib.network.RetrofitService
import com.xhly.manageapp.bean.log.LogPushBean
import com.xhly.manageapp.bean.log.LogdOperateBean
import com.xhly.manageapp.network.log.LogService
import com.xhly.manageapp.ui.login.netservice.LoginService

open class BaseViewModel : CommonBaseViewModel() {
    protected val loginService: LoginService by lazy { RetrofitService.create<LoginService>() }
    private val logService: LogService = RetrofitService.create<LogService>()
    private val pwdResult = MutableLiveData<Boolean>()
    val pwdResultData: LiveData<Boolean> = pwdResult
    private val timeResult = MutableLiveData<Long>()
    val timeResultData: LiveData<Long> = timeResult
    /**
     * 解除当前锁屏
     */
    fun postPwdDetail(code: String, sn: String) {
        launchUI {
            val map = HashMap<String, Any>()
            map["sn"] = sn
            val result = loginService.postPwdDetail(map)
            if (result.code == 0) {
                pwdResult.value = result.obj.controlPwd.equals(code)
            } else {
                pwdResult.value = false
            }
        }
    }

    /**
     * 发送事件日志
     */
    fun eventLog(operateBean: LogdOperateBean) {
        launchUI {
            logService.postLogdoperateAdd(operateBean)
        }
    }

    /**
     * 发送事件推送日志
     */
    fun postLogPushAdd(logPushBean: LogPushBean) {
        launchUI {
            logService.postLogPushAdd(logPushBean)
        }
    }
    /**
     * 同步服务器的时间
     */
    fun postSyncTime(){
        launchUI {
            val startTime = System.currentTimeMillis()
            val postSyncTime = loginService.postSyncTime()
            if (postSyncTime.code==0){
                val endTime = System.currentTimeMillis()
                val obj = postSyncTime.obj
                timeResult.value=obj+(endTime-startTime)/2
            }else{
                if (!postSyncTime.msg.isNullOrEmpty()){
                   netMessage.value=postSyncTime.msg
                }
            }
        }
    }
}